`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 07/12/2015 11:39:16 PM
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top(
input clk,
output enable_D1,//right most digit
output enable_D2,
output enable_D3,
output enable_D4,//left most digit
output ca,
output cd,
output ce,
output cf,
output cb,
output cc,
output cg,
output dp
    );

wire clkout1; //internal signal for the divided clock output
wire clkout2; //internal signal for the divided clock output
wire clkOut; // internal signal for the divided clock output
wire Q0,Q1,Q2; // internal signal for the counter output 

clkdivider UclkDiv (
    .clk(clk), // master clock
	 .clkout1(clkout1), // 381.4697265625Hz Q17
	 .clkout2(clkout2), //190.73486328125Hz Q18
    .clkOut(clkOut) //clock out in the BUFG
);

counter Ucounter (
    .clk(clkOut), // clock out in the BUFG
    .Q0(Q0), // Q0 output (digit0)
	 .Q1(Q1), // Q1 output (digit1)
	 .Q2(Q2) // Q2 output (digit2)
);

wire n,o,p; //internal signal to control the on / off of 3 digits

assign enable_D4 = 1'b1; //turn off the left most digit which is D4 
and U1 (n,clkout2,clkout1); // use AND gate to turn on and off the digit so that only one digit is on at a time
and U2 (o,clkout2,~clkout1); // use AND gate to turn on and off the Digit so that only one digit is on at a time
and U3 (p,~clkout2,clkout1); // use AND gate to turn on and off the Digit so that only one digit is on at a time

not (enable_D1,n); // n = clkout2 & clkout1, enable_D1 is low (on) when both clkout2 and clkout1 is high
not (enable_D2,o); // o = clkout2 & ~clkout1, enable_D2 is low (on) when clkouut2 is high and clkcout1 is low
not (enable_D3,p); // p = ~clkout2 & clkout1, enable_D3 is low (on) when clkout2 is low and clkout1 is high 


// Use the truth table to generate logic equations
assign ca = (enable_D1==0) ? Q0:  ((enable_D2==0)? Q1: ((enable_D3==0) ? Q2:1'b1)); //use conditional operator 
assign cb = 1'b0; // cb is always on
assign cc = 1'b0; // cc is always on 
assign cd = ca; //cd output is same as ca 
assign ce = ca; //ce output is same as ca
assign cf = ca; //cf output is same as ca
assign cg = 1'b1; // as we only need to have zero or one, so cg is off all times
assign dp = 1'b1; //turn off the decimal point 
    
endmodule
